crossTE <- function(data){
  
  dx1<-data[which(data$DXCHANGE==1),]  #subseting para Normal
  dx2<-data[which(data$DXCHANGE==2),]  #subseting para MCI
  dx3<-data[which(data$DXCHANGE==3),]  #subseting para Alzheimern*0
  dx1$count<-c(1:nrow(dx1))
  dx2$count<-c(1:nrow(dx2))
  dx3$count<-c(1:nrow(dx3))
  dc1<-dx1[sample(nrow(dx1), trunc(nrow(dx1)*0.2)),] #31 125
  val1<-dx1[dx1$count %in% dc1$count,]
  train1<-dx1[!dx1$count %in% dc1$count,]
  train1$count<-NULL
  val1$count<-NULL
  dc2<-dx2[sample(nrow(dx2), trunc(nrow(dx2)*0.2)),] #80 321
  val2<-dx2[dx2$count %in% dc2$count,]
  train2<-dx2[!dx2$count %in% dc2$count,]
  train2$count<-NULL
  val2$count<-NULL
  dc3<-dx3[sample(nrow(dx3), trunc(nrow(dx3)*0.2)),] #20 80
  val3<-dx3[dx3$count %in% dc3$count,]
  train3<-dx3[!dx3$count %in% dc3$count,]
  train3$count<-NULL
  val3$count<-NULL
  val<-rbind(dc1,dc2,dc3) 
  train1<-rbind(train1,SMOTE(train1,50,7),SMOTE(train1,100,7))
  train3<-rbind(train3,SMOTE(train3,300,7))
  ss<-min(nrow(train1),nrow(train2),nrow(train3))
  train1<-train1[sample(nrow(train1), ss), ] #sampling for normal lesser size 
  train2<-train2[sample(nrow(train2), ss), ] #sampling for MCI lesser size
  train3<-train3[sample(nrow(train3), ss), ] #sampling for Alzheimer lesser size
  train<-rbind(train1,train2,train3)
  cl<-c(rep(1,ss),rep(2,ss),rep(3,ss)) #vetor com classes num?rico a principio
  cl<-factor(cl)
  val$count<-NULL
  val$DXCHANGE<-NULL
  train$DXCHANGE<-NULL
  
  bst<-0
  for (k in seq(3,21,2)){
    res<-knn(train,val, cl, k)
    a1<-sum(data.frame(as.numeric(res))[1:nrow(val1),1]==1)
    a2<-sum(data.frame(as.numeric(res))[1:nrow(val1),1]==2)
    a3<-sum(data.frame(as.numeric(res))[1:nrow(val1),1]==3)
    res1<-c(a1,a2,a3)/nrow(val1)
    a1<-sum(data.frame(as.numeric(res))[(nrow(val1)+1):(nrow(val1)+nrow(val2)),1]==1)
    a2<-sum(data.frame(as.numeric(res))[(nrow(val1)+1):(nrow(val1)+nrow(val2)),1]==2)
    a3<-sum(data.frame(as.numeric(res))[(nrow(val1)+1):(nrow(val1)+nrow(val2)),1]==3)
    res2<-c(a1,a2,a3)/nrow(val2)
    a1<-sum(data.frame(as.numeric(res))[(nrow(val1)+nrow(val2)+1):(nrow(val1)+nrow(val2)+nrow(val3)),1]==1)
    a2<-sum(data.frame(as.numeric(res))[(nrow(val1)+nrow(val2)+1):(nrow(val1)+nrow(val2)+nrow(val3)),1]==2)
    a3<-sum(data.frame(as.numeric(res))[(nrow(val1)+nrow(val2)+1):(nrow(val1)+nrow(val2)+nrow(val3)),1]==3)
    res3<-c(a1,a2,a3)/nrow(val3)
    ave<-(res1[1]+res2[2]+res3[3])/3
    if (bst<ave){
      bst<-ave
      K<-k
      Res1<-res1
      Res2<-res2
      Res3<-res3
    }
  }
  conf<-rbind(Res1,Res2,Res3)
  return(conf)
  SMOTE <- function(t,N,k){
    
    if (N<100) #Se o n?mero ? menor que 100
    {
      t<-t[sample(nrow(t),nrow(t)*N/100), ] #tomando a porcentagem de t randomicamente
      N<-100
    }
    
    
    N<-N/10^(nchar(N)-1) #inteiro correspondente ao aumento (int)*N/100
    synth<-NULL #iniciando dados sintetica
    for (i in 1:nrow(t)){
      dista<-NULL
      for(j in 1:nrow(t)){
        dista<-rbind(dista,c(dist(rbind(t[i,],t[j,])),i,j)) #calculo dos pontos mais pr?ximos de i
      }
      dista<-dista[order(dista[,1]),] #ordenando os pontos mais pr?ximos de i
      dista<-dista[1:k+1,] #tomando os k vizinhos mais proximos de i
      synth<-populate(dista,N,t,synth) #criando novos dados a partir de i e seus vizinhos mais proximos
    }
    colnames(synth)<-colnames(t)
    
    return(synth)
  }

  populate<-function(Dista,n,t,synth){
    while (n!=0){
      dif<-t[Dista[1,2],]-t[sample(Dista[,3],1),] #diferen?a entre i e um dos seus vizinhos mais proximos
      gap<-runif(1,0,1) #valor aleatorio entre 0 e 1
      synth<-rbind(synth,t[Dista[1,3],]+gap*dif) # ponto entre i e seu vizinho mais pr?ximo
      n<-n-1
    }
    return(synth)
  }
}